/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

Authors:    Marco Mellia, Gloria Bogliolo, Ana Paula Couto, Richard Lobb
			Telecomunication Networks Group
			Politecnico di Torino
			Torino, Italy
			mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file
	Defines the ASAwareOverlay subtype of the Overlay class.
 */

#ifndef _AS_AWARE_OVERLAY_H_
#define _AS_AWARE_OVERLAY_H_

#include <vector>
#include "types.h"
#include "overlay.h"


/// A ASAwareOverlay.
class ASAwareOverlay : public Overlay {
public:
	ASAwareOverlay(
		size_t num_peers,	///< The number of peers in the overlay
		size_t degree		///< The number of random neighbours to choose.
	);

private:
	void set_edges(size_t degree);
	void set_peers(size_t num_peers);
};


#endif // _AS_AWARE_OVERLAY_H_
