/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

 Authors: Marco Mellia, Gloria Bogliolo, Ana Paula Couto, Richard Lobb
  	      Telecomunication Networks Group
  	      Politecnico di Torino
  	      Torino, Italy
  	      mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @mainpage
	This is the index page for the doxygen-generated documentation
	of the simulator program developed by the Telecommunications
	Network Group at Politecnico di Torino.

	Click on either the <i>Files</i> or the <i>Classes</i> tab to see
	the documentation.
 */
/*! @file globals.h
	Defines global variables and constants for the simulator.
 */

#ifndef _globals_h_
#define _globals_h_

#define chunk_trace 0

#include "types.h"

// CONFIGURATION CONSTANTS. All loaded from config.txt.

extern double  gTimeJitter;			///< A jitter of 0 to +gTimeJitter is added to event times

extern double  gBandwidthFractVariation;	///< The upload rates are uniformly distributed with MEAN given by MEANCLASSx and this variance  

extern double  gProbChunkError;	///< When a chunk arrives to the peer, it is "lost" with this probability.

// Chunk characteristics
extern double  gChunkSize;			///< Mb

// Source characteristics
extern double  gVideoRate;			///< Mbps

// Sliding window playout-delay
extern double  gPlayoutDelay;		///< Seconds

// The maximum degree of TREE overlays (TODO: can we lose this?!)
extern size_t  gMaxTreeDegree;

// The timeout on chunk delivery failure
extern double gChunkTimeoutInterval;	///< msecs

// Whether to handle all contemporary deliveries before selecting what to send
extern bool gContemporaryDeliveries;

// Deadline increment value for DLc scheduler
extern ChunkDeadline gDLIncrement;

extern ChunkDeadline gDLIncrDiff;

// Number of priority classes
extern int gPriorityClassCount;

// GLOBAL VARIABLES
extern long int gSeed;			///< The current random number gSeed (see random.h)
extern Time gCurrentTime;		///< The current simulator time
extern PropertyMap config;		///< The configuration map

// fills global variables based on propertymap (config file and command line)
void initialize_globals();
#endif  // ifndef _globals_h_
