/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

Authors: Maurizio Munafo', Marco Mellia, Richard Lobb, Gloria Bogliolo, 
/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

Authors:    Maurizio Munafo', Marco Mellia, Gloria Bogliolo, 
Ana Paula Couto, Richard Lobb
Telecomunication Networks Group
Politecnico di Torino
Torino, Italy
mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file
Defines the various subclasses of the Peer class. These are
primarily just different schedulers, i.e., each one defines its own
version of the virtual schedule_chunk method of Peer.
*/

#ifndef _LATEST_RANDOM_PEER_H_
#define _LATEST_RANDOM_PEER_H_

#include "types.h"
#include "peer.h"
#include "globals.h"

//================= LATEST_RANDOM ======================
// This algorithm selects the most recent chunk (subject to there being existing
// neighbours who don't have it) and a random neighbour (of those who don't have it).

// CONFIG Peer equivalent: 
//	"ChunkFirst BestChunk AllChunks Recentness BestPeer NeedsSelected UnitWtPeer"

class LatestRandomPeer : public Peer
{
public:
	LatestRandomPeer(
		Bandwidth upload_bandwidth,		///< The upload_bandwidth of the peer
		Bandwidth download_bandwidth,	///< The download_bandwidth of the peer
		size_t peer_class				///< The bandwidth class of the peer
	) : Peer(upload_bandwidth, download_bandwidth, peer_class) {}
	virtual void schedule_new_chunk();
};

#endif //_LATEST_RANDOM_PEER_H_
