/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

Authors:    Marco Mellia, Gloria Bogliolo, Ana Paula Couto, Richard Lobb
			Telecomunication Networks Group
			Politecnico di Torino
			Torino, Italy
			mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file
	Defines the PrebuiltOverlay class, which is a bit of a hack that
	reads the DegreeAtEnd.out and LinksAtEnd.out files from an earlier
	simulator run, and uses them to build an identical fresh overlay.
 */

#ifndef _PRE_BUILT_OVERLAY_H_
#define _PRE_BUILT_OVERLAY_H_

#include "overlay.h"

/// A PrebuiltOverlay reads two files in the form of degree.out and links.out
/// to build an overlay. The actual file names are defined in config.txt by the
/// properties DEGREE_FILE_NAME and LINKS_FILE_NAME. If those properties are not
/// given, the defaultfiles are called DegreeAtEnd.out and LinksAtEnd.out
/// and must be in the current directory
class PrebuiltOverlay : public Overlay {
public:
	PrebuiltOverlay();	///< Constructor takes no parameters. Gets file names from config.txt
};


#endif // _PRE_BUILT_OVERLAY_H_
