/*********************************************************************/
/* Copyright (C) 2008  Politecnico di Torino

Authors:    Marco Mellia, Gloria Bogliolo, Ana Paula Couto, Richard Lobb
			Telecomunication Networks Group
			Politecnico di Torino
			Torino, Italy
			mellia@mail.tlc.polito.it, anapaula@tlc.polito.it

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*********************************************************************/

/*! @file
    Define the OldSimHost subclass of Host, which is used to simulate
	the behaviour of the old simulator (which didn't have a network layer).
 */

#ifndef _TWEAKED_OLD_SIM_HOST_H_
#define _TWEAKED_OLD_SIM_HOST_H_

#include "types.h"
#include "oldsimhost.h"
#include "host.h"

/// A TweakedOldSimHost is like the OldSimHost except that when a high-bandwidth
/// host is feeding a low-bandwidth one, the source completes its send in a time
/// determined by its own upload bandwidth, and gets called back at that time, allowing
/// it to schedule other chunks.
class TweakedOldSimHost : public OldSimHost {
public:
	TweakedOldSimHost(Bandwidth uploadBW, Bandwidth downloadBW,
		   Latency upload_latency, Latency download_latency);
	virtual void send_chunk(PChunk chunk, Path path);
	virtual void chunk_scheduled(PChunk chunk, Path path);

};

#endif // _TWEAKED_OLD_SIM_HOST_H_
